program taonde;
uses svplus;

const
tamprog = 449;

var
i : integer;
script : array[1..tamprog] of string = (
'*',
'*Programa para rastrear encomendas;',
'*Autor: Fabiano Ferreira;',
'*Em 23/07/2019;',
'*Atualizado em 30/09/2020;',
'*Atualizado em 23/07/2024;',
'*Baseado na ideia de Patrick Barbosa,',
'*Que desenvolveu antes um script de interface com a pgina dos correios;',
'*',
'',
'*',
'*rotinas:',
'*ObtemCodigoObjeto: aceita a entrada de um cdigo de rastreio;',
'*pesquisacodigoobjeto: pesquisa na base pelo objeto vinculado ao cdigo de rastreio;',
'*processainformacoesobjeto: extrai somente as informaes necessrias para trabalhar depois;',
'*Escolheropcao: Apresenta um menu com as seguintes opes:',
'*Ver detalhes do objeto;',
'*Monitorar estado do objeto;',
'*Nova consulta;',
'*Sair;',
'*',
'',
'chama @autoinstala',
'dir troca $dirtaonde',
'',
'escreve mudo "Taonde - rastreamento de objetos"',
'mensagem "sons\to_ini.wav"',
'@inicio',
'chama @obtemcodigoobjeto',
'chama @pesquisacodigoobjeto',
'chama @processainformacoesobjeto',
'chama @verultimaatualizacao',
'escreve ""',
'chama @escolheropcao',
'desvia @inicio',
'*',
'',
'@obtemcodigoobjeto',
'seja o $dirtaonde',
'concatena o "\lista\objeto.txt"',
'busca b o',
'se b <> ""',
'chama @pegaobjetonoarquivo',
'seno',
'escreve mudo "Entre com o cdigo do objeto a pesquisar:"',
'mensagem "sons\to_dig_cod.wav"',
'le $codigo',
'se $codigo = "" termina mudo',
'fim se',
'escreve mudo "Aguarde"',
'mensagem "sons\to_agua.wav"',
'retorna',
'',
'@pesquisacodigoobjeto',
'seja $pesquisa ""',
'seja $arqtemp $dirtaonde',
'concatena $arqtemp "\temp\sro.html"',
'seja $baseurl "httpS://www.websro.com.br/detalhes.php?P_COD_UNI="',
'concatena $pesquisa $baseurl',
'concatena $pesquisa $codigo',
'',
'remove $arqtemp &',
'trazdarede $pesquisa $arqtemp 0 "" "webvox" x',
'retorna',
'',
'@processainformacoesobjeto',
'seja $arqinfo $dirtaonde',
'concatena $arqinfo "\temp\sro.info"',
'seja m ""',
'',
'remove $arqinfo &',
'abre #1 $arqtemp',
'le #1 l',
'checa c',
'enquanto c = 0',
'se l *=* "<p><br /><br />"',
'fecha #1',
'desvia @erro',
'seno',
'se l *=* "                   <B><FONT COLOR=''#ff0000''>"',
'fecha #1',
'desvia @erro',
'fim se',
'concatena m l',
'le #1 l',
'checa c',
'fim enquanto',
'fecha #1',
'',
'abre #1 $arqinfo &',
'seja p pos "<ul class=""linha_status"" style="""">" m',
'enquanto p > 0',
'seja t tamanho m',
'copia m m p t',
'seja p pos "</ul>" m',
'subtrai p 1',
'copia z m 1 p',
'chama @leeventos',
'',
'escreve #1 "----------"',
'seja p pos "</ul>" m',
'seja t tamanho m',
'copia m m p t',
'seja p pos "<ul class=""linha_status"" style="""">" m',
'fim enquanto',
'fecha #1',
'retorna',
'',
'*',
'',
'@leeventos',
'seja p pos "<li>" z',
'enquanto p > 0',
'soma p 4',
'seja t tamanho z',
'copia z z p t',
'seja p pos "</li>" z',
'subtrai p 1',
'copia $evento z 1 p',
'utf8paraansi $evento',
'substitui $evento "<b>" ""',
'substitui $evento "</b>" ""',
'escreve #1 $evento',
'soma p 1',
'seja t tamanho z',
'copia z z p t',
'',
'seja p pos "<li>" z',
'fim enquanto',
'retorna',
'*',
'',
'@escolheropcao',
'seja $numeroitem 1',
'seja $primeiroitem "Ver detalhes do objeto"',
'seja $segundoitem "Monitorar"',
'seja $terceiroitem "Nova consulta"',
'seja $quartoitem "sair"',
'',
'menu cria 1 1 30 3',
'menu adiciona $primeiroitem',
'menu adiciona $segundoitem',
'menu adiciona $terceiroitem',
'menu adiciona $quartoitem',
'@fixomenuitem',
'Escreve mudo "Escolha sua opo"',
'mensagem "sons\to_esc_opc.wav"',
'',
'menu executa $numeroitem $letraitem $textoitem',
'se $letraitem = "#13"',
'se $numeroitem = 1 chama @verdetalhes',
'se $numeroitem = 2 chama @monitorar',
'se $numeroitem = 3 menu termina',
'se $numeroitem = 3 retorna',
'se $numeroitem = 4 chama @sair',
'se $numeroitem < 3 desvia @escolheropcao',
'fim se',
'se $letraitem = "#27" chama @sair',
'desvia @fixomenuitem',
'*',
'',
'@verultimaatualizacao',
'seja $numnull 1',
'Escreve mudo "ltima atualizao:"',
'mensagem "sons\to_ult_atu.wav"',
'escreve ""',
'',
'abre #1 $arqinfo',
'le #1 l',
'enquanto l <> "----------"',
'escreve l',
'le #1 l',
'fim enquanto',
'fecha #1',
'retorna',
'*',
'',
'@verdetalhes',
'menu termina',
'seja $numnull 1',
'Escreve mudo "Detalhes do objeto:"',
'mensagem "sons\to_det_obj.wav"',
'escreve ""',
'',
'menu cria 1 1 80 30',
'',
'abre #1 $arqinfo',
'le #1 l',
'checa c',
'enquanto c = 0',
'se l <> ""menu adiciona l',
'le #1 l',
'checa c',
'fim enquanto',
'fecha #1',
'',
'Escreve mudo "Leia com as setas"',
'mensagem "sons\to_ler_set.wav"',
'@fixomenunull',
'menu executa $numnull $tecnull $texnull',
'se $tecnull = "#27"',
'menu termina',
'retorna',
'fim se',
'desvia @fixomenunull',
'*',
'',
'@monitorar',
'Escreve mudo "Iniciando monitor de objetos para "$codigo',
'mensagem "sons\to_ini_mon.wav"',
'fala $codigo',
'seja $iniciamonitor "taonde_mon "',
'concatena $iniciamonitor $codigo',
'concatena $iniciamonitor " 10"',
'executa $iniciamonitor &',
'espera 2',
'@monitorando',
'bipa 1',
'le mudo t &',
'se t = "#13"',
'busca b $arqinfo',
'se b = "" desvia @monitorando',
'abre #1 $arqinfo',
'le #1 $ult_evento',
'fecha #1',
'bipa 1',
'escreve $ult_evento',
'seno',
'se t = "#27"',
' chama @paramonitor',
'retorna',
'fim se',
'desvia @monitorando',
'*',
'',
'@paramonitor',
'remove "stop"&',
'abre #1 "stop"&',
'fecha #1',
'escreve mudo "Parando monitor"',
'mensagem "sons\to_par_mon.wav"',
'chama @pesquisacodigoobjeto',
'chama @processainformacoesobjeto',
'retorna',
'*',
'',
'@sair',
'escreve mudo "Deseja sair?"',
'mensagem "sons\to_des_sai.wav"',
'le mudo o &',
'se o = "s"',
'escreve mudo"At logo."',
'mensagem "sons\to_fui.wav"',
'termina mudo',
'seno',
'se o = "n"',
'retorna',
'seno',
'desvia @sair',
'fim  se',
'*',
'',
'@erro',
'se l *=* "<p><br /><br />"',
'seja p pos "<p><br" l',
'soma p 15',
'seja t tamanho l',
'copia l l p t',
'seja p pos "</p>" l',
'subtrai p 1',
'copia l l 1 p',
'substitui l "<br />" ""',
'seno',
'se l *=* "                   <B><FONT COLOR=''#ff0000''>"',
'seja p pos "                   <B><FONT COLOR=''#ff0000''>" l',
'soma p 25',
'seja t tamanho l',
'copia l l p t',
'seja p pos "<" l',
'subtrai p 1',
'copia l l 1 p',
'fim se',
'utf8paraansi l',
'escreve l',
'escreve ""',
'Escreve mudo "Programa encerrado."',
'mensagem "sons\to_err.wav"',
'termina mudo',
'',
'@pegaobjetonoarquivo',
'seja $qtd_codigos 0',
'abre #1 o',
'le #1 $codigo',
'le #1 $temmais',
'se $temmais <> ""',
'fecha #1',
'',
'menu cria 1 1 60 30',
'abre #1 o',
'seja n 0',
'le #1 l',
'checa c',
'enquanto c = 0',
'soma n 1',
'seja p pos "=" l',
'subtrai p 1',
'copia l l 1 p',
'se l = "" chama @trata_obj_sem_nome',
'menu adiciona l',
'le #1 l',
'checa c',
'fim enquanto',
'fecha #1',
'',
'@fixomenuobjetos',
'Escreve mudo "Selecione o objeto a consultar:"',
'mensagem "sons\to_sel_obj.wav"',
'menu executa $numeroobjeto $letraobjeto $codigo',
'se $letraobjeto = "#13" chama @consulta_selec',
'se $letraobjeto = "#13" retorna',
'se $letraobjeto = "#27" termina mudo',
'desvia @fixomenuobjetos',
'seno',
'seja p pos "=" $codigo',
'soma p 1',
'seja t tamanho $codigo',
'copia $codigo $codigo p t',
'retorna',
'fim se',
'',
'@trata_obj_sem_nome',
'seja l "Objeto "',
'concatena l n',
'retorna',
'',
'@consulta_selec',
'abre #1 o',
'repete r $numeroobjeto',
'le #1 $codigo',
'fim repete',
'fecha #1',
'seja p pos "=" $codigo',
'soma p 1',
'seja t tamanho $codigo',
'copia $codigo $codigo p t',
'retorna',
'',
'*----------------------------',
'*--*Instalao automtica de scripts;',
'@autoinstala',
'*--*Obtem o diretrio do perfil de usurio',
'seja $arqlog "result.log"',
'seja $obtemuserprofile "obtemuserprofile.bat"',
'',
'remove $obtemuserprofile &',
'abre #1 $obtemuserprofile &',
'escreve #1 "@echo off"',
'escreve #1 "chcp 1252"',
'escreve #1 "echo %userprofile%>"$arqlog" 2>&1"',
'escreve #1 "exit"',
'fecha #1',
'',
'seja $comando $obtemuserprofile',
'executa $comando &&',
'espera 1',
'seja $esperacmd 0',
'existeprog "cmd.exe" x',
'enquanto x = 1',
'se $esperacmd = 20 desvia @para_de_esperar_cmd',
'soma $esperacmd 1',
'espera ms 500',
'existeprog "cmd.exe" x',
'fim enquanto',
'@para_de_esperar_cmd',
'*abandona o loop e continua executando.',
'',
'busca b $arqlog',
'enquanto b = ""',
'espera ms 500',
'busca b $arqlog',
'fim enquanto',
'',
'abre #1 $arqlog',
'le #1 $userprofile',
'fecha #1',
'seja $userprofile trim $userprofile',
'remove $arqlog',
'remove $obtemuserprofile',
'',
'seja $taondedir $userprofile',
'concatena $taondedir "\taonde.dir"',
'busca b $taondedir',
'se b = ""',
'busca $dirtaonde dir',
'',
'abre #1 $taondedir &',
'escreve #1 $dirtaonde',
'fecha #1',
'chama @cria_reg_dosvox_ini',
'seno',
'abre #1 $taondedir',
'le #1 $dirtaonde',
'fecha #1',
'fim se',
'retorna',
'',
'*--*Cria uma entrada no dosvox.ini para facilitar a abertura do programa.',
'@cria_reg_dosvox_ini',
'Escreve "Criando entrada no Dosvox.ini."',
'Escreve "Da prxima vez, voc poder abrir o programa pressionando r, z, t"',
'seja $arqatu $dirtaonde',
'concatena $arqatu "\taonde.atu"',
'remove $arqatu &',
'abre #1 $arqatu &',
'escreve #1 "[PROGREDE]"',
'escreve #1 "Rede23=Z,[PROGSANFER],-RPRGSAN,Programas do portal Sanfer Site"',
'escreve #1 ""',
'escreve #1 "[PROGSANFER]"',
'escreve #1 "Rede7=T,"$dirtaonde"\TAONDE.EXE,-REDEITA,Rastrear encomendas dos correios"',
'fecha #1',
'chama @obtemdirdosvox',
'seja $comando $dirdosvox',
'concatena $comando "\atuvox.exe """',
'concatena $comando $arqatu',
'concatena $comando """"',
'executa $comando &',
'espera 1',
'existeprog "atuvox.exe" x',
'enquanto x = 1',
'espera ms 500',
'existeprog "atuvox.exe" x',
'fim enquanto',
'espera 1',
'remove $arqatu &',
'retorna',
'',
'*--*Obtem o diretrio padro de instalao do Dosvox;',
'@obtemdirdosvox',
'seja $dosvoxini $userprofile',
'concatena $dosvoxini "\appdata\roaming\dosvox\dosvox.ini"',
'abre #1 $dosvoxini',
'le #1 $dirdosvox',
'enquanto no $dirdosvox =* "PGMDOSVOX="',
'le #1 $dirdosvox',
'fim enquanto',
'fecha #1',
'seja t tamanho $dirdosvox',
'copia $dirdosvox $dirdosvox 11 t',
'retorna');

begin
inicializa ('taonde');
for i := 1 to tamprog do
carregascript(script[i],i);
processa;
end.
