program taonde_mon;
uses svplus;

const
tamprog = 273;

var
i : integer;
script : array[1..tamprog] of string = (
'*Programa para monitorar a mudana de estado de objetos;',
'*Por Fabiano Ferreira;',
'*Em 23/07/2019;',
'*Atualizado em 30/09/2020 - incluido monitorar sequoia;',
'*',
'*Forma de usar:',
'*taonde_mon codigorastreio, tempomonitor;',
'*Codigorastreio:  o cdigo de rastreamento fornecido pela transportadora de um objeto postado;',
'*Temporastreio  o tempo, em segundos, que o programa ir verificar se houve mudana do estado de objeto;',
'*',
'*Para fechar, pode matar o processo pelo gerenciador de tarefas ou pelo comando taskkill,',
'*ou pode tambm criar um arquivo vazio chamado stop,',
'*no diretrio corrente;',
'*',
'chama @autoinstala',
'chama @inicia',
'seja $primeiravez 1',
'chama @monitora',
'chama @finaliza',
'*',
'',
'@inicia',
'seja $arqinfo $dirtaonde',
'concatena $arqinfo "\temp\sro.info"',
'seja $entrada params',
'se $entrada = 0 termina mudo',
'tela minimizada',
'seja $codigo palavra 2 $entrada',
'seja $tempoemsegundos palavra 3 $entrada',
'',
'remove $arqinfo &',
'remove "stop" &',
'seja $tocasom $dirtaonde',
'concatena $tocasom "\sons\waterdrop.wav"',
'repete r 5',
'toca $tocasom',
'fim repete',
'retorna',
'',
'@monitora',
'seja $mudou_estado_objeto 0',
'',
'se $primeiravez = 0 espera $tempoemsegundos',
'chama @pesquisacodigoobjeto',
'chama @processainformacoesobjeto',
'se $parar = 1 retorna',
'se $primeiravez = 1',
'seja $tocasom $dirtaonde',
'concatena $tocasom "\sons\blimblimblom.wav"',
' toca $tocasom',
' escreve "ltima atualizao para o objeto: "$codigo',
' escreve $ult_evento',
'seno',
'se $mudou_estado_objeto = 1 seja $tocasom $dirtaonde',
'se $mudou_estado_objeto = 1 concatena $tocasom "\sons\"',
'se $mudou_estado_objeto = 1 toca $tocasom',
'se $mudou_estado_objeto = 1 escreve "ltima atualizao para o objeto: "$codigo',
'se $mudou_estado_objeto = 1 escreve ""',
'se $mudou_estado_objeto = 1 escreve $ult_evento',
'fim se',
'seja $primeiravez 0',
'desvia @monitora',
'*********',
'@pesquisacodigoobjeto',
'seja $pesquisa ""',
'seja $arqtemp $dirtaonde',
'concatena $arqtemp "\temp\sro.html"',
'',
'seja $baseurl "httpS://www.websro.com.br/detalhes.php?P_COD_UNI="',
'concatena $pesquisa $baseurl',
'concatena $pesquisa $codigo',
'remove $arqtemp &',
'trazdarede $pesquisa $arqtemp 0 "" "webvox" x',
'retorna',
'*',
'',
'@processainformacoesobjeto',
'busca b "stop"',
'se b <> ""',
'seja $parar 1',
' retorna',
'fim se',
'',
'seja m ""',
'',
'abre #1 $arqtemp',
'le #1 l',
'checa c',
'enquanto c = 0',
'se l *=* "<p><br /><br />"',
'fecha #1',
'desvia @erro',
'fim se',
'',
'concatena m l',
'le #1 l',
'checa c',
'fim enquanto',
'fecha #1',
'',
'seja p pos "<ul class=""linha_status"" style="""">" m',
'seja t tamanho m',
'copia m m p t',
'seja p pos "</ul>" m',
'subtrai p 1',
'copia z m 1 p',
'chama @leeventos',
'retorna',
'',
'*',
'',
'@leeventos',
'seja $ult_evento ""',
'seja p pos "<li>" z',
'enquanto p > 0',
'soma p 4',
'seja t tamanho z',
'copia z z p t',
'seja p pos "</li>" z',
'subtrai p 1',
'copia $evento z 1 p',
'utf8paraansi $evento',
'substitui $evento "<b>" ""',
'substitui $evento "</b>" ""',
'concatena $ult_evento $evento',
'concatena $ult_evento "; "',
'soma p 1',
'seja t tamanho z',
'copia z z p t',
'',
'seja p pos "<li>" z',
'fim enquanto',
'',
'busca b $arqinfo',
'se b = ""',
'abre #1 $arqinfo &',
'escreve #1 $ult_evento',
'fecha #1',
'seno',
'abre #1 $arqinfo',
'le #1 $evento',
'fecha #1',
'',
'se $evento <> $ult_evento seja $mudou_estado_objeto 1',
'remove $arqinfo',
'abre #1 $arqinfo &',
'escreve #1 $ult_evento',
'fecha #1',
'fim se',
'retorna',
'',
'*',
'',
'@erro',
'seja p pos "<p><br" l',
'soma p 15',
'seja t tamanho l',
'copia l l p t',
'seja p pos "</p>" l',
'subtrai p 1',
'copia l l 1 p',
'substitui l "<br />" ""',
'utf8paraansi l',
'escreve l',
'escreve ""',
'Escreve "Programa encerrado."',
'termina mudo',
'',
'@finaliza',
'remove "stop"',
'termina mudo',
'*----------------------------',
'*--*Instalao automtica de scripts;',
'@autoinstala',
'*--*Obtem o diretrio do perfil de usurio',
'seja $arqlog "result.log"',
'seja $obtemuserprofile "obtemuserprofile.bat"',
'',
'remove $obtemuserprofile &',
'abre #1 $obtemuserprofile &',
'escreve #1 "@echo off"',
'escreve #1 "chcp 1252"',
'escreve #1 "echo %userprofile%>"$arqlog" 2>&1"',
'escreve #1 "exit"',
'fecha #1',
'',
'seja $comando $obtemuserprofile',
'executa $comando &&',
'espera 1',
'seja $esperacmd 0',
'existeprog "cmd.exe" x',
'enquanto x = 1',
'se $esperacmd = 20 desvia @para_de_esperar_cmd',
'soma $esperacmd 1',
'espera ms 500',
'existeprog "cmd.exe" x',
'fim enquanto',
'@para_de_esperar_cmd',
'*abandona o loop e continua executando.',
'',
'busca b $arqlog',
'enquanto b = ""',
'espera ms 500',
'busca b $arqlog',
'fim enquanto',
'',
'abre #1 $arqlog',
'le #1 $userprofile',
'fecha #1',
'seja $userprofile trim $userprofile',
'remove $arqlog',
'remove $obtemuserprofile',
'',
'seja $taondedir $userprofile',
'concatena $taondedir "\taonde.dir"',
'busca b $taondedir',
'se b = ""',
'busca $dirtaonde dir',
'',
'abre #1 $taondedir &',
'escreve #1 $dirtaonde',
'fecha #1',
'chama @cria_reg_dosvox_ini',
'seno',
'abre #1 $taondedir',
'le #1 $dirtaonde',
'fecha #1',
'fim se',
'retorna',
'',
'*--*Cria uma entrada no dosvox.ini para facilitar a abertura do programa.',
'@cria_reg_dosvox_ini',
'Escreve "Criando entrada no Dosvox.ini."',
'Escreve "Da prxima vez, voc poder abrir o programa pressionando r, z, t"',
'seja $arqatu $dirtaonde',
'concatena $arqatu "\taonde.atu"',
'remove $arqatu &',
'abre #1 $arqatu &',
'escreve #1 "[PROGREDE]"',
'escreve #1 "Rede23=Z,[PROGSANFER],-RPRGSAN,Programas do portal Sanfer Site"',
'escreve #1 ""',
'escreve #1 "[PROGSANFER]"',
'escreve #1 "Rede7=T,"$dirtaonde"\TAONDE.EXE,-REDEITA,Rastrear encomendas dos correios"',
'fecha #1',
'chama @obtemdirdosvox',
'seja $comando $dirdosvox',
'concatena $comando "\atuvox.exe """',
'concatena $comando $arqatu',
'concatena $comando """"',
'executa $comando &',
'espera 1',
'existeprog "atuvox.exe" x',
'enquanto x = 1',
'espera ms 500',
'existeprog "atuvox.exe" x',
'fim enquanto',
'espera 1',
'remove $arqatu &',
'retorna',
'',
'*--*Obtem o diretrio padro de instalao do Dosvox;',
'@obtemdirdosvox',
'seja $dosvoxini $userprofile',
'concatena $dosvoxini "\appdata\roaming\dosvox\dosvox.ini"',
'abre #1 $dosvoxini',
'le #1 $dirdosvox',
'enquanto no $dirdosvox =* "PGMDOSVOX="',
'le #1 $dirdosvox',
'fim enquanto',
'fecha #1',
'seja t tamanho $dirdosvox',
'copia $dirdosvox $dirdosvox 11 t',
'retorna');

begin
inicializa ('taonde_mon');
for i := 1 to tamprog do
carregascript(script[i],i);
processa;
end.
